<?php

############################
############################
############################
############################
####### RapidCode.iR #######
############################
############################
############################
############################

require_once "vendor/autoload.php";
use GuzzleHttp\Client;

header("Content-Type: application/json");

define("GITHUB_CLIENT_ID", "کلاینت آیدی");
define("GITHUB_CLIENT_SECRET", "کلاینت سکرت");
define("GITHUB_URL_ACCESS_TOKEN", "https://github.com/login/oauth/access_token");
define("GITHUB_URL_API", "https://api.github.com/user");

$response_msg = ["msg" => "invalid token", "status" => 0];

function httpRequest($url, $data, $method = "GET", $header) {

	$client = new Client([
		'timeout' => 5.0,
		'verify' => false,
	]);

	$response = $client->request($method, $url, [
		'headers' => $header,
		'form_params' => $data,
	]);

	$content = (string) $response->getBody();

	return json_decode($content, true);
}

$github_code = $_GET['code'] ?? false;

if ($github_code) {

	$data = [
		"client_id" => GITHUB_CLIENT_ID,
		"client_secret" => GITHUB_CLIENT_SECRET,
		"code" => $github_code,
	];

	$content = httpRequest(GITHUB_URL_ACCESS_TOKEN, $data, "POST", array(
		"Content-Type" => "application/x-www-form-urlencoded",
		"Accept" => "application/json",
	));

	if (!empty($content['access_token'])) {
		$access_token = $content['access_token'];

		$content = httpRequest(GITHUB_URL_API, array(), "GET", array(
			"Authorization" => "token {$access_token}",
		));

		if (!empty($content['login']) && !empty($content['node_id'])) {
			$response_msg = ["user" => $content['login'], "msg" => "successfully logged in (:", "status" => 1];
			setcookie("auth" , json_encode($response_msg));
			header("Location: http://{$_SERVER['SERVER_NAME']}");
		}

	}

}

echo json_encode($response_msg);

?>